Bug 458184 - NetworkManager gets fooled by RNDIS with no override possible
NetworkManager gets fooled by RNDIS with no override possible
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: NetworkManager (Show other bugs)
9
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dan Williams
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-06 17:38 EDT by H. Peter Anvin
Modified: 2009-07-14 12:55 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 12:55:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to fix ifcfg-rh nm-system-settings plugin which was incorrectly applying the IPADDR as the value of GATEWAY (1.31 KB, patch)
2009-01-07 23:11 EST, Charles R. Anderson
no flags Details | Diff

  None (edit)
Description H. Peter Anvin 2008-08-06 17:38:51 EDT
Description of problem:

Windows Mobile based cell phones use an Ethernet-like protocol, RNDIS, over USB for synchronization and Internet sharing.  They also use USB for charging the cell phone.

When plugged in, they will answer DHCP on the 169.254/16 network (despite this being nonsense) and give a default route, even though that may not actually lead anywhere.

Unfortunately, NetworkManager will always switch to this bogus "Ethernet".  Selecting a wireless network will cause it to switch over to it, and then immediately switch back.

The routing table ends up looking something like:

Kernel IP routing table
Destination     Gateway         Genmask         Flags Metric Ref    Use Iface
169.254.2.0     0.0.0.0         255.255.255.0   U     0      0        0 eth1
192.168.122.0   0.0.0.0         255.255.255.0   U     0      0        0 virbr0
172.27.2.0      0.0.0.0         255.255.254.0   U     0      0        0 wlan0
0.0.0.0         169.254.2.1     0.0.0.0         UG    0      0        0 eth1

There needs to be an (easy) way to disable this network, at least for the purpose of being the default gateway.

One presumably doesn't want it to be automatically disabled, in case this is used for using the cell phone as an Internet-sharing device for 3G or EDGE.


Version-Release number of selected component (if applicable):
NetworkManager-0.7.0-0.9.4.svn3675.fc9.x86_64

How reproducible:
Every time


Steps to Reproduce:
1. While on a wireless network, plug in a Windows Mobile 6 smartphone.
2. Check the resulting routing table.
3. Try to re-enable the wireless network.
  
Actual results:


Expected results:


Additional info:
Comment 1 Charles R. Anderson 2008-11-13 17:14:29 EST
I've seen this.  It is a pretty braindead behavior on behalf of the mobile device, but I suppose we need to make a workaround for it.
Comment 2 Charles R. Anderson 2009-01-07 23:11:37 EST
Created attachment 328435 [details]
patch to fix ifcfg-rh nm-system-settings plugin which was incorrectly applying the IPADDR as the value of GATEWAY

I just tried this with a WM6.1-based phone, and I don't get a gateway from the RNDIS device.  Do you still see this problem?

I'm using NetworkManager-0.7.0-1.git20090102.fc10 plus a patch (attached) and this is what I see with nm-tool:

- Device: eth2 ----------------------------------------------------------------
  Type:              Wired
  Driver:            rndis_host
  State:             connected
  Default:           no
  HW Address:        80:00:60:0F:E8:00

  Capabilities:
    Supported:       yes
    Carrier Detect:  yes

  Wired Settings

  IPv4 Settings:
    Address:         169.254.2.2
    Prefix:          24 (255.255.255.0)
    Gateway:         0.0.0.0

Now, I just fixed a bug that duplicates a connection's IP Address as its gateway if there isn't a gateway, so perhaps that is what you were hitting.  See if the attached patch fixes the issue for you.
Comment 3 Robert Townley 2009-02-25 16:12:45 EST
First, i don't know much.  But on multiple occasions, the newsgroup knowledge of /sbin/route makes us forget about the much more powerful /sbin/ip command, otherwise known as policy routing.

Wouldn't it be better to use Policy Routing for this to enable multiple default gateways based on priority - this bogus gateway would have the least priority / used last.  Most people will not have routed or some form of dynamic routing bgp  turned on. 

PolicyRouting.org has a free online book.
Comment 4 Jessica Sterling 2009-03-08 16:36:26 EDT
This bug has been triaged.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 5 Bug Zapper 2009-06-09 22:23:52 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2009-07-14 12:55:10 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.